#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

static const int root = 0;

int main(int argc, char *argv[]) {
  int sz, me;

  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &me);

  {
    int size = 3;
    int *array = (int *)malloc(size * sizeof(int));

    if (me == root) {
      array[0] = 13;
      array[1] = 42;
      array[2] = 79;
    }

    MPI_Bcast(array, size, MPI_INT, root, MPI_COMM_WORLD);

    printf("At %d: %d %d %d\n", me, array[0], array[1], array[2]);
  }

  MPI_Finalize();
}
