#include <stdio.h>
#include <mpi.h>

int main(int argc, char *argv[]) {
  int sz, me, namelen;
  char processor_name[MPI_MAX_PROCESSOR_NAME];

  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &me);
  MPI_Get_processor_name(processor_name, &namelen);

  printf("Process %d on %s out of %d\n", me, processor_name, sz);

  MPI_Finalize();
}
