#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

static const int root = 0;

int main(int argc, char *argv[]) {
  int sz, me, target, hit, anyhit;

  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &me);

  target = atoi(argv[1]);

  hit = (target == me);

  printf("At %d: %d\n", me, hit);

  if (argc == 2)
    MPI_Reduce(&hit, &anyhit, 1, MPI_INT, MPI_LOR, root, MPI_COMM_WORLD);
  else
    MPI_Allreduce(&hit, &anyhit, 1, MPI_INT, MPI_LOR, MPI_COMM_WORLD);

  printf("Result at %d: %d\n", me, anyhit);

  MPI_Finalize();
}
